//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once
#include "ResizableLib\ResizableDialog.h"
#include "SplitterControl.h"
#include "BtnST.h"
#include "TabCtrl.hpp"
#include "UploadListCtrl.h"
#include "DownloadListCtrl.h"
#include "QueueListCtrl.h"
#include "ClientListCtrl.h"
#include "downloadclientsctrl.h"//[TPT] - TBH Transfers Window Style
#include "ToolTips\PPToolTip.h" // [TPT] - MFCK [addon] - New Tooltips [Rayita]
// [TPT] - MFCK [addon] - New Tooltips [Rayita]
#define UPLOAD_WND		0
#define	QUEUE_WND		1
#define KNOWN_WND		2
#define TRANSF_WND		3
#define UPDOWN_WND		4
#define DOWNLOAD_WND	5
// [TPT] - MFCK [addon] - New Tooltips [Rayita]

class CUploadListCtrl;
class CDownloadListCtrl;
class CQueueListCtrl;
class CClientListCtrl;

class CTransferWnd : public CResizableDialog
{
	DECLARE_DYNAMIC(CTransferWnd)

public:
	CTransferWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTransferWnd();
	void	ShowQueueCount(uint32 number);
	void	SwitchUploadList();
	void	UpdateListCount(uint8 listindex);
	void	OnBnClickedQueueRefreshButton();
	void	Localize();
	void	UpdateCatTabTitles();
	bool 	isUploadQueueVisible() { return (windowtransferstate == 0); }//[TPT] - TBH Transfers Window Style
	bool	isDownloadListVisible() { return ((showlist == IDC_DOWNLOADLIST) || (showlist == IDC_DOWNLOADLIST+IDC_UPLOADLIST)); } // [TPT] - TransferWindow Fix
	void	VerifyCatTabSize();
	void SetDlgItemFocus(int nID);// [TPT] - MFCK [addon] - New Tooltips [Rayita]
	bool	downloadlistactive;

	// Dialog Data
	enum { IDD = IDD_TRANSFER };
	CUploadListCtrl		uploadlistctrl;
	CDownloadListCtrl	downloadlistctrl;
	CQueueListCtrl		queuelistctrl;
	CClientListCtrl		clientlistctrl;
	CDownloadClientsCtrl	downloadclientsctrl;//[TPT] - TBH Transfers Window Style
	//CToolTipCtrl m_tooltip;// [TPT] - MFCK [addon] - New Tooltips [Rayita]

protected:
	void DoResize(int delta);
	void UpdateSplitterRange();
	void SetInitLayout();
	void DoSplitResize(int delta);
	CSplitterControl m_wndSplitter;
	void SetAllIcons();
	CString GetCatTitle(int catid);

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//[TPT] - TBH Transfers Window Style
	void OnBnClickedChangeView();
	void OnBnClickedDownUploads();
	void OnBnClickedDownloads();
	void OnBnClickedUploads();
	void OnBnClickedQueue();
	void OnBnClickedClient();
	void OnBnClickedTransfers();
	
	DECLARE_MESSAGE_MAP()

private:
	void OnDblclickDltab();
	int GetTabUnderMouse(CPoint* point);
	uint8	windowtransferstate;
	CButtonST	m_uplBtn;
	TabControl	m_dlTab;
	int	rightclickindex;
	void EditCatTabLabel(int index,CString newlabel);
	// [TPT] - MFCK [addon] - New Tooltips [Rayita]
	//int GetItemUnderMouse(CListCtrl* ctrl);
	//void UpdateTabToolTips() {UpdateTabToolTips(-1);}
	//void UpdateTabToolTips(int tab);
	//CString GetTabStatistic(uint8 tab);
	// [TPT] - MFCK [addon] - New Tooltips [Rayita]
	int m_nDragIndex;
	int m_nDropIndex;
	int m_nLastCatTT;
	bool m_bIsDragging;
	CImageList* m_pDragImage;
	HICON icon_download;
	POINT	m_pLastMousePoint;
	//[TPT] - TBH Transfers Window Style
	CButtonST	m_btnChangeView;
	CButtonST	m_btnDownUploads;
	CButtonST	m_btnDownloads;
	CButtonST	m_btnUploads;
	CButtonST	m_btnQueue;
	CButtonST	m_btnTransfers;
	CButtonST	m_btnClient;
	uint16 showlist;	
	void ShowList(uint16 list);


public:
	afx_msg void OnHoverUploadList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHoverDownloadList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickDltab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnBegindrag(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnShowWindow(BOOL bShow, UINT nStatus); //<<-- [TPT] - enkeyDEV(th1) -notifier-
	void OnMouseMove(UINT nFlags, CPoint point);
	void OnLButtonUp(UINT nFlags, CPoint point);
	virtual BOOL OnCommand(WPARAM wParam,LPARAM lParam );
	int AddCategorie(CString newtitle,CString newincoming,CString newcomment,CString newautocat,bool addTab=true);
	afx_msg void OnLvnKeydownDownloadlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnSysColorChange();
// [TPT] - MFCK [addon] - New Tooltips [Rayita]
private:
	CMuleListCtrl* lists_list[6];
	CPreferences* app_prefs;
	CImageList m_ImageList;
	CPPToolTip m_ttip;
	CPPToolTip m_tabtip;
	CPPToolTip m_othertips;
	void UpdateTabToolTips();
	void UpdateToolTips();
	int m_iOldToolTipItem[DOWNLOAD_WND];
	int GetClientImage(CUpDownClient* client);
protected:
	afx_msg BOOL OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult);
public:
	CImageList* GetImageList() { return &m_ImageList; }
	void DrawClientImage(CDC *dc, POINT &point, CUpDownClient* client);
	void SetTTDelay();
// [TPT] - MFCK [addon] - New Tooltips [Rayita]
};
